//bcc32 -W -O2 -c main.cpp
//ilink32 -aa main.obj c0w32.obj draw.obj move.obj clear.obj cursor.obj,lan.exe,,cw32mt.lib import32.lib,,lan.res

#include <windows.h>
#include <time.h>
#include <string.h>
#include "lan.h"

LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK VerDlgProc(HWND, UINT, WPARAM, LPARAM);
ATOM InitApp(HINSTANCE);
BOOL InitInstance(HINSTANCE, int);
void MyCheckMenu(HMENU);

int parts[6][6];

BOOL bMove[6][6];
	
char szClassName[] = "lan";
HBITMAP hPartsBmp, hPCBmp;
HINSTANCE hInst;
HBRUSH hBkBrush;
BOOL bSound = TRUE;	//炷ǂ
int pic_type = SIMPLE;	//G
HWND hParent;
HACCEL hAccel;
char UserName[256];

int WINAPI WinMain(HINSTANCE hCurInst, HINSTANCE, LPSTR szArg, int nCmdShow)
{
	MSG msg;
	
	hInst = hCurInst;
	
	if (strcmp(szArg, "/U") == 0) {
		UnInstall();
		return 0;
	}
	
	if (!InitApp(hCurInst))
		return FALSE;
	if (!InitInstance(hCurInst, nCmdShow))
		return FALSE;
	
	hAccel = LoadAccelerators(hCurInst, "MYACCEL");
	if (hAccel == NULL)
		MessageBox(NULL, "Error -no accelerator handl", "Error", MB_OK | MB_ICONHAND);
	if (hParent == NULL)
		MessageBox(NULL, "Error -no window handl", "Error", MB_OK | MB_ICONHAND);
	
	while(GetMessage(&msg, NULL, 0, 0)){
		if (!TranslateAccelerator(hParent, hAccel, &msg)) {
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}
	return msg.wParam;
}

ATOM InitApp(HINSTANCE hInst)
{
	WNDCLASSEX wc;
	
	hBkBrush = CreateSolidBrush(RGB(200, 255, 255));
	
	wc.cbSize = sizeof(WNDCLASSEX);
	wc.style = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc = WndProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = hInst;
	wc.hIcon = LoadIcon(hInst, "LANICON");
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground = hBkBrush;
	wc.lpszMenuName = "MYMENU";
	wc.lpszClassName = (LPCSTR)szClassName;
	wc.hIconSm = LoadIcon(hInst, "LANICON_S");
	return(RegisterClassEx(&wc));
}

BOOL InitInstance(HINSTANCE hInst, int nCmdShow)
{
	HWND hWnd;
	RECT rc = {0, 0, 270 + PARTS_W * 6, 40 + PARTS_H * 6};
	
	AdjustWindowRect(&rc, WS_OVERLAPPEDWINDOW & ~WS_THICKFRAME | WS_CLIPCHILDREN, TRUE);
	
	hWnd = CreateWindow(szClassName,
		"Connect Game",
		WS_OVERLAPPEDWINDOW & ~WS_THICKFRAME | WS_CLIPCHILDREN,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		rc.right - rc.left,
		rc.bottom - rc.top,
		NULL,
		NULL,
		hInst,
		NULL);
	if (!hWnd)
		return FALSE;
	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);
	hParent = hWnd;
	return TRUE;
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT msg, WPARAM wp, LPARAM lp)
{
	int id;
	time_t long_time;
	static HMENU hMenu;
	RECT mode_rc = {20, 100, 105, 120};
	
	switch(msg){
		case WM_CREATE:
			
			ReadReg();	
			
			hMenu = GetMenu(hWnd);
			CheckMenuItem(hMenu, IDM_SND, MF_CHECKED | MF_BYCOMMAND);
			CheckMenuItem(hMenu, IDM_RND, MF_CHECKED | MF_BYCOMMAND);
			CheckMenuItem(hMenu, IDM_SIMPLE, MF_CHECKED | MF_BYCOMMAND);
									
			if (!CreateScoreWindow(hWnd))
				MessageBox(hWnd, "G[łB(XRAEBhE)", "Error", MB_OK | MB_ICONHAND);
			
			InitScore();
			
			time(&long_time);
			srand((UINT)long_time);
			
			hPartsBmp = LoadBitmap(hInst, "PARTS_BMP");
			hPCBmp = LoadBitmap(hInst, "PC_BMP");
			
			hUpCur = LoadCursor(hInst, "UP_CUR");
			hDownCur = LoadCursor(hInst, "DOWN_CUR");
			hLeftCur = LoadCursor(hInst, "LEFT_CUR");
			hRightCur = LoadCursor(hInst, "RIGHT_CUR");
			
			CreateQuestion(hWnd);
			
			break;
		case WM_TIMER:
			SetTimer();
			break;
		case WM_MOUSEMOVE:
			OnMouseMove(lp);
			break;
		case WM_COMMAND:
			switch(LOWORD(wp)) {
				case IDM_END:
					SendMessage(hWnd, WM_CLOSE, 0, 0L);
					break;
				case IDM_START:
					CreateQuestion(hWnd);
					break;
				case IDM_RETRAY:
					Unsort(hWnd);
					break;
				case IDM_SND:
					if (bSound)
						bSound = FALSE;
					else
						bSound = TRUE;
					break;
				case IDM_1:
					level = 1;
					CreateQuestion(hWnd);
					break;
				case IDM_2:
					level = 2;
					CreateQuestion(hWnd);
					break;
				case IDM_3:
					level = 3;
					CreateQuestion(hWnd);
					break;
				case IDM_RND:
					level = RANDOM;
					CreateQuestion(hWnd);
					break;
				case IDM_COM:
					pic_type = COM;
					InvalidateRect(hWnd, NULL, FALSE);
					break;
				case IDM_SIMPLE:
					pic_type = SIMPLE;
					InvalidateRect(hWnd, NULL, FALSE);
					break;
				case IDM_VER:
					DialogBox(hInst, "VERSION_DLG", hWnd, (DLGPROC)VerDlgProc);
					break;
			}
			break;
		case WM_INITMENUPOPUP:
			MyCheckMenu((HMENU)wp);
			break;
		case WM_LBUTTONDOWN:
			OnLButtonDown(hWnd, lp);
			break;
		case WM_PAINT:
			MyPaint(hWnd);
			break;
		case WM_KEYDOWN:
			if (wp == 0x45) {
				if (unsort_num == 1) {
					unsort_num = 1000;
					InvalidateRect(hScoreWnd, &mode_rc, TRUE);
				} else {
					unsort_num = 1;
					InvalidateRect(hScoreWnd, &mode_rc, FALSE);
				}
			}
			break;
		case WM_CLOSE:
			id = MessageBox(hWnd,
				(LPCSTR)"Q[I܂",
				(LPCSTR)"ImF",
				MB_YESNO | MB_ICONQUESTION);
			if (id == IDYES) {
				DeleteObject(hBkBrush);
				DeleteObject(hPartsBmp);
				DeleteObject(hPCBmp);
				DeleteObject(hScoreBrush);
				DeleteObject(hScoreFont);
				DestroyWindow(hWnd);
				DestroyWindow(hScoreWnd);
				DeleteMyTimer(hWnd);
				WriteReg();
			}
			break;
		case WM_DESTROY:
			PostQuitMessage(0);
			break;
		default:
			return(DefWindowProc(hWnd, msg, wp, lp));
	}
	return 0L;
}

void MyCheckMenu(HMENU hMenu)
{
	CheckMenuItem(hMenu, IDM_1, MF_UNCHECKED | MF_BYCOMMAND);
	CheckMenuItem(hMenu, IDM_2, MF_UNCHECKED | MF_BYCOMMAND);
	CheckMenuItem(hMenu, IDM_3, MF_UNCHECKED | MF_BYCOMMAND);
	CheckMenuItem(hMenu, IDM_RND, MF_UNCHECKED | MF_BYCOMMAND);
	
	switch (level) {
		case 1:
			CheckMenuItem(hMenu, IDM_1, MF_CHECKED | MF_BYCOMMAND);
			break;
		case 2:
			CheckMenuItem(hMenu, IDM_2, MF_CHECKED | MF_BYCOMMAND);
			break;
		case 3:
			CheckMenuItem(hMenu, IDM_3, MF_CHECKED | MF_BYCOMMAND);
			break;
		case RANDOM:
			CheckMenuItem(hMenu, IDM_RND, MF_CHECKED | MF_BYCOMMAND);
			break;
		default:
			MessageBox(NULL, "Error -check menu-", "Error", MB_OK | MB_ICONHAND);
	}
	
	CheckMenuItem(hMenu, IDM_COM, MF_UNCHECKED | MF_BYCOMMAND);
	CheckMenuItem(hMenu, IDM_SIMPLE, MF_UNCHECKED | MF_BYCOMMAND);
	
	switch (pic_type) {
		case COM:
			CheckMenuItem(hMenu, IDM_COM, MF_CHECKED | MF_BYCOMMAND);
			break;
		case SIMPLE:
			CheckMenuItem(hMenu, IDM_SIMPLE, MF_CHECKED | MF_BYCOMMAND);
			break;
		default:
			MessageBox(NULL, "Error -check menu-", "Error", MB_OK | MB_ICONHAND);
	}
	
	if (bSound)
		CheckMenuItem(hMenu, IDM_SND, MF_CHECKED | MF_BYCOMMAND);
	else
		CheckMenuItem(hMenu, IDM_SND, MF_UNCHECKED | MF_BYCOMMAND);
	
	return;
}

LRESULT CALLBACK VerDlgProc(HWND hWnd, UINT msg, WPARAM wp, LPARAM)
{
	char music_str[MAX_PATH];
	
	switch (msg) {
		case WM_INITDIALOG:
			GetWindowsDirectory(music_str, sizeof(music_str));
			strcat(music_str, "\\media\\The Microsoft Sound.wav");
			sndPlaySound(music_str, SND_ASYNC);
			
			SetDlgItemText(hWnd, IDC_USERNAME, UserName);
			break;
		case WM_COMMAND:
			switch (LOWORD(wp)) {
				case IDOK:
					EndDialog(hWnd, IDOK);
					break;
				case IDCANCEL:
					EndDialog(hWnd, IDCANCEL);
					break;
				default:
					return FALSE;
			}
		default:
			return FALSE;
	}
	return TRUE;
}