//bcc32 -W -O2 -c score.cpp

#include <windows.h>
#include <time.h>
#include "lan.h"

HBRUSH hScoreBrush;
HWND hScoreWnd;
int level = RANDOM, click, move;
PASS_TIME pass_time;	//oߎ
time_t start_time;
HFONT hScoreFont;
BOOL bTimer = FALSE;

LRESULT CALLBACK ScoreWndProc(HWND, UINT, WPARAM, LPARAM);

BOOL CreateScoreWindow(HWND hWnd)
{
	WNDCLASSEX wc;
	
	hScoreBrush = CreateSolidBrush(RGB(200, 255, 200));
	wc.cbSize = sizeof(WNDCLASSEX);
	wc.style = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc = ScoreWndProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = hInst;
	wc.hIcon = NULL;
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground = hScoreBrush;
	wc.lpszMenuName = NULL;
	wc.lpszClassName = "score";
	wc.hIconSm = NULL;
	if (!RegisterClassEx(&wc))
		return FALSE;
	
	hScoreWnd = CreateWindow("score", "", WS_CHILD | WS_VISIBLE,
				120+PARTS_W*6, 0, 150, 40+PARTS_H*6, hWnd, NULL, hInst, NULL);	
	
	if (!hScoreWnd)
		return FALSE;
	
	UpdateWindow(hScoreWnd);

	
	return TRUE;
}

LRESULT CALLBACK ScoreWndProc(HWND hWnd, UINT msg, WPARAM wp, LPARAM lp)
{
	HDC hdc, hmdc;
	RECT rc;
	HBITMAP	hBmp;
	char level_str[20], click_str[20], move_str[20], time_str[20];
	PAINTSTRUCT ps;
	char easy_mode[] = "easy mode";
	
	switch(msg) {
		case WM_CREATE:
			hScoreFont = CreateFont(16, 0, 0, 0, FW_BOLD, FALSE, FALSE, FALSE,
								DEFAULT_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,
								PROOF_QUALITY, DEFAULT_PITCH | FF_MODERN, "lr SVbN");
			break;
		case WM_PAINT:
			hdc = BeginPaint(hWnd, &ps);
				
			/***  ^Cg  ***/
	
			hBmp = LoadBitmap(hInst, "SCORE_BMP");
			hmdc = CreateCompatibleDC(hdc);
			SelectObject(hmdc, hBmp);
			BitBlt(hdc, 10, 20, 120, 50, hmdc, 0, 0, SRCCOPY);
			DeleteDC(hmdc);
			DeleteObject(hBmp);
	
			/***  XRA  ***/
	
			SelectObject(hdc, hScoreFont);
			SetBkColor(hdc, RGB(200, 255, 200));
			SetTextColor(hdc, RGB(0, 0, 255));
			
			if (level == RANDOM)
				strcpy(level_str, "Level    RANDOM");
			else
				wsprintf(level_str, "Level         %d", level);
			wsprintf(click_str, "Click      %4d", click);
			wsprintf(move_str,  "Move       %4d", move);
			wsprintf(time_str,  "Time    %d:%02d'%02d", pass_time.hour,
					pass_time.minute, pass_time.second);
			
			TextOut(hdc, 5, 130, level_str, strlen(level_str));
			TextOut(hdc, 5, 170, click_str, strlen(click_str));
			TextOut(hdc, 5, 210, move_str, strlen(move_str));
			TextOut(hdc, 5, 250, time_str, strlen(time_str));
			
			if (unsort_num == 1) {
				SetTextColor(hdc, RGB(255, 0, 0));
				TextOut(hdc, 20, 100, easy_mode, strlen(easy_mode));
			}
			
			EndPaint(hWnd, &ps);
			
			break;
		default:
			return (DefWindowProc(hWnd, msg, wp, lp));
	}
	return 0L;
}

void SetTimer(void)
{
	time_t now_time, long_time;
	struct tm *lp_struct_tm;
	RECT rc;
	
	time(&now_time);
	
	long_time = now_time - start_time;
	
	lp_struct_tm = localtime(&long_time);
	
	pass_time.hour = lp_struct_tm->tm_hour - 9;
	pass_time.minute = lp_struct_tm->tm_min;
	pass_time.second = lp_struct_tm->tm_sec;
		
	InvalidateRect(hScoreWnd, NULL, FALSE);	
	return;
}

void InitScore(void)
{
	click = 0;
	move = 0;
	time(&start_time);
	SetTimer();
	
	InvalidateRect(hScoreWnd, NULL, FALSE);
	
	return;
}

void CreateMyTimer(HWND hWnd)
{
		
	if (!bTimer) {
		if (!SetTimer(hWnd, ID_TIMER, 300, NULL))
			MessageBox(hWnd, "Error -timer-", "Error", MB_OK | MB_ICONHAND);
		time(&start_time);
	}
	
	bTimer = TRUE;
	
	InvalidateRect(hScoreWnd, NULL, FALSE);
	
	return;
}

void DeleteMyTimer(HWND hWnd)
{
	if (bTimer) {
		if (!KillTimer(hWnd, ID_TIMER))
			MessageBox(hWnd, "Error -kill timer-", "Error", MB_OK | MB_ICONHAND);
	}
	
	bTimer = FALSE;
	
	return;
}
